(* ::Package:: *)

<<xAct`xTensor`


(*Set up: global*)
(*Definition of the Manifold and global rulemakers *)
DefManifold[M4,4,{a,b,c,d,f,p,h,i,j,k,l,n,q,v,w}]
$MixedDers=False;
Off[ToCanonical::noident]
$PrePrint=ScreenDollarIndices;
ApplyRule[expr_]:=MakeRule[Evaluate[List@@expr],MetricOn->All,ContractMetrics->True]



DefMetric[-1,m[-a,-b],CDflat,SymbolOfCovD->{"%","\!\(\*OverscriptBox[\(\[Del]\), \(\[FilledSmallCircle]\)]\)"}]


DefMetric[{3,1,0},g[-a,-b],CD,{";","\[Del]"}]



DefTensor[testvector[-a],M4,PrintAs->"v"]


<<xAct`xCoba`


DefChart[Sp,M4,{0,1,2,3},{T[],R[],\[Theta][],\[Phi][]}]


MatrixForm[MinkowskiSp={
{-1,0,0,0},
{0,1,0,0},
{0,0,R[]^2,0},
{0,0,0,R[]^2 Sin[\[Theta][]]^2}
}]


MetricInBasis[m,-Sp,MinkowskiSp]


MetricCompute[m,Sp,All,CVSimplify->Simplify]


MetricCompute[m,Sp,"Riemann"[-1,-1,-1,-1],CVSimplify->Simplify]
Last@TensorValues[RiemannCDflat]


MetricCompute[m,Sp,"Christoffel"[1,-1,-1],CVSimplify->Simplify]
Last@TensorValues[ChristoffelCDflatPDSp]



DefTensor[L[-a],M4,PrintAs->"L"]
DefTensor[Lbar[-a],M4,PrintAs->"\[CapitalLSlash]"]



(**************************************definitions for Toy Model ***************************************)


DefConstantSymbol[gamma2,PrintAs->"\!\(\*SubscriptBox[\(\[Gamma]\), \(2\)]\)"]


DefScalarFunction[PiPhiT, PrintAs->"\!\(\*SubscriptBox[\(b\), \(\[Pi]\)]\)"]
DefScalarFunction[PiuglyT, PrintAs->"\!\(\*SubscriptBox[\(u\), \(\[Pi]\)]\)"]
DefScalarFunction[PivarPhiT, PrintAs->"\!\(\*SubscriptBox[\(g\), \(\[Pi]\)]\)"]
DefScalarFunction[Phi, PrintAs->"b"]
DefScalarFunction[ugly, PrintAs->"u"]
DefScalarFunction[varPhi, PrintAs->"g"]
DefScalarFunction[PhiT, PrintAs->"\!\(\*SubscriptBox[\(b\), \(T\)]\)"]
DefScalarFunction[uglyT, PrintAs->"\!\(\*SubscriptBox[\(u\), \(T\)]\)"]
DefScalarFunction[varPhiT, PrintAs->"\!\(\*SubscriptBox[\(g\), \(T\)]\)"]
DefScalarFunction[PhiR, PrintAs->"\!\(\*SubscriptBox[\(b\), \(R\)]\)"]
DefScalarFunction[uglyR, PrintAs->"\!\(\*SubscriptBox[\(u\), \(R\)]\)"]
DefScalarFunction[varPhiR, PrintAs->"\!\(\*SubscriptBox[\(g\), \(R\)]\)"]
DefTensor[SpacetimeDerivativePhi[-a],M4,PrintAs->"b"]
DefTensor[SpacetimeDerivativeugly[-a],M4,PrintAs->"u"]
DefTensor[SpacetimeDerivativevarPhi[-a],M4,PrintAs->"g"]
DefTensor[ReductionConstraint[-a],M4,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(b\)]\)\!\(\*
StyleBox[\")\",\nFontSize->18]\)"]
DefTensor[varReductionConstraint[-a],M4,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(g\)]\)\!\(\*
StyleBox[\")\",\nFontSize->18]\)"]
DefTensor[uglyReductionConstraint[-a],M4,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(u\)]\)\!\(\*
StyleBox[\")\",\nFontSize->18]\)"]
DefScalarFunction[reductCT,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(b\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(T\)]\)"]
DefScalarFunction[reductCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(b\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]
DefScalarFunction[varReductCT,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(g\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(T\)]\)"]
DefScalarFunction[varReductCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(g\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]
DefScalarFunction[uglyreductCT,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(u\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(T\)]\)"]
DefScalarFunction[uglyreductCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(u\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]

DefScalarFunction[DLphi,PrintAs->"(\!\(\*SuperscriptBox[\(b\), \(+\)]\))"]
DefScalarFunction[DLbarphi,PrintAs->"(\!\(\*SuperscriptBox[\(b\), \(-\)]\))"]
DefScalarFunction[DLugly,PrintAs->"(\!\(\*SuperscriptBox[\(u\), \(+\)]\))"]
DefScalarFunction[DLbarugly,PrintAs->"(\!\(\*SuperscriptBox[\(u\), \(-\)]\))"]
DefScalarFunction[varDLphi,PrintAs->"(\!\(\*SuperscriptBox[\(g\), \(+\)]\))"]
DefScalarFunction[varDLbarphi,PrintAs->"(\!\(\*SuperscriptBox[\(g\), \(-\)]\))"]
DefScalarFunction[RescDLphi,PrintAs->"(\!\(\*SuperscriptBox[\(\[ScriptCapitalB]\), \(+\)]\))"]
DefScalarFunction[RescDLbarphi,PrintAs->"(\!\(\*SuperscriptBox[\(\[ScriptCapitalB]\), \(-\)]\))"]
DefScalarFunction[RescPhi,PrintAs->"\[ScriptCapitalB]"]
DefScalarFunction[varRescDLphi,PrintAs->"(\!\(\*SuperscriptBox[\(G\), \(+\)]\))"]
DefScalarFunction[varRescDLbarphi,PrintAs->"(\!\(\*SuperscriptBox[\(G\), \(-\)]\))"]
DefScalarFunction[varRescPhi,PrintAs->"(G)"]
DefScalarFunction[RescDLugly,PrintAs->"(\!\(\*SuperscriptBox[\(U\), \(+\)]\))"]
DefScalarFunction[RescDLbarugly,PrintAs->"(\!\(\*SuperscriptBox[\(U\), \(-\)]\))"]
DefScalarFunction[Rescugly,PrintAs->"(U)"]

DefScalarFunction[RescaledCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(B\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]
DefScalarFunction[varRescaledCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(G\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]
DefScalarFunction[uglyRescaledCR,PrintAs->"\!\(\*
StyleBox[\"(\",\nFontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(U\)]\)\!\(\*SubscriptBox[
StyleBox[\")\",\nFontSize->18], \(R\)]\)"]




DefScalarFunction[X,PrintAs->"(B)"]
DefScalarFunction[Xp,PrintAs->"(\!\(\*SuperscriptBox[\(B\), \(+\)]\))"]
DefScalarFunction[Xm,PrintAs->"(\!\(\*SuperscriptBox[\(B\), \(-\)]\))"]
DefScalarFunction[XA1,PrintAs->"\!\(\*SubscriptBox[\(B\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[XA2,PrintAs->"\!\(\*SubscriptBox[\(B\), SubscriptBox[\(A\), \(2\)]]\)"]


SubstitutePi=PhiT==-PiPhiT
SubstitutevarPi=varPhiT==-PivarPhiT
SubstituteuglyPi=uglyT==-PiuglyT
NicePrintingPhiT=SpacetimeDerivativePhi[{0,-Sp}]==PhiT
NicePrintingvarPhiT=SpacetimeDerivativevarPhi[{0,-Sp}]==varPhiT
NicePrintinguglyT=SpacetimeDerivativeugly[{0,-Sp}]==uglyT
NicePrintingPhiR=SpacetimeDerivativePhi[{1,-Sp}]==PhiR
NicePrintingvarPhiR=SpacetimeDerivativevarPhi[{1,-Sp}]==varPhiR
NicePrintinguglyR=SpacetimeDerivativeugly[{1,-Sp}]==uglyR
NicePrintingCT=ReductionConstraint[{0,-Sp}]==reductCT
NicePrintingCR=ReductionConstraint[{1,-Sp}]==reductCR
varNicePrintingCT=varReductionConstraint[{0,-Sp}]==varReductCT
varNicePrintingCR=varReductionConstraint[{1,-Sp}]==varReductCR
uglyNicePrintingCT=uglyReductionConstraint[{0,-Sp}]==uglyreductCT
uglyNicePrintingCR=uglyReductionConstraint[{1,-Sp}]==uglyreductCR



RuleSpacetimeReductionVariable=CDflat[-a]@Phi==SpacetimeDerivativePhi[-a]
RuleSpacetimeReductionVariablevarphi=CDflat[-a]@varPhi==SpacetimeDerivativevarPhi[-a]
RuleSpacetimeReductionVariableugly=CDflat[-a]@ugly==SpacetimeDerivativeugly[-a]
ReductionConstraintDefinition=ReductionConstraint[-a]==CDflat[-a]@Phi-SpacetimeDerivativePhi[-a]
varReductionConstraintDefinition=varReductionConstraint[-a]==CDflat[-a]@varPhi-SpacetimeDerivativevarPhi[-a]
uglyReductionConstraintDefinition=uglyReductionConstraint[-a]==CDflat[-a]@ugly-SpacetimeDerivativeugly[-a]





(************************** true angular comps *************************)


(* ::Code:: *)
(**)


DefScalarFunction[PhiA1, PrintAs->"\!\(\*SubscriptBox[\(b\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[PhiA2, PrintAs->"\!\(\*SubscriptBox[\(b\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[varPhiA1, PrintAs->"\!\(\*SubscriptBox[\(g\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[varPhiA2, PrintAs->"\!\(\*SubscriptBox[\(g\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[uglyA1, PrintAs->"\!\(\*SubscriptBox[\(u\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[uglyA2, PrintAs->"\!\(\*SubscriptBox[\(u\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[RescPhiA1,PrintAs->"\!\(\*SubscriptBox[\(\[ScriptCapitalB]\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[RescPhiA2,PrintAs->"\!\(\*SubscriptBox[\(\[ScriptCapitalB]\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[varRescPhiA1,PrintAs->"\!\(\*SubscriptBox[\(G\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[varRescPhiA2,PrintAs->"\!\(\*SubscriptBox[\(G\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[RescuglyA1,PrintAs->"\!\(\*SubscriptBox[\(U\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[RescuglyA2,PrintAs->"\!\(\*SubscriptBox[\(U\), SubscriptBox[\(A\), \(2\)]]\)"]
DefScalarFunction[reductCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(b\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[reductCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(b\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]
DefScalarFunction[varReductCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(g\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[varReductCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(g\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]
DefScalarFunction[uglyReductCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(u\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[uglyReductCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(C\), \(u\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]
DefScalarFunction[RescaledCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(B\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[RescaledCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(B\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]
DefScalarFunction[varRescaledCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(G\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[varRescaledCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(G\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]
DefScalarFunction[uglyRescaledCA1,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(U\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"1\"]]\)"]
DefScalarFunction[uglyRescaledCA2,PrintAs->"\!\(\*StyleBox[\"(\",FontSize->18]\)\!\(\*SuperscriptBox[\(\[DoubleStruckCapitalC]\), \(U\)]\)\!\(\*SubscriptBox[StyleBox[\")\",FontSize->18], SubscriptBox[\"A\", \"2\"]]\)"]



NicePrintingPhiA1=SpacetimeDerivativePhi[{2,-Sp}]==PhiA1
NicePrintingPhiA2=SpacetimeDerivativePhi[{3,-Sp}]==PhiA2
NicePrintingvarPhiA1=SpacetimeDerivativevarPhi[{2,-Sp}]==varPhiA1
NicePrintingvarPhiA2=SpacetimeDerivativevarPhi[{3,-Sp}]==varPhiA2
NicePrintinguglyA1=SpacetimeDerivativeugly[{2,-Sp}]==uglyA1
NicePrintinguglyA2=SpacetimeDerivativeugly[{3,-Sp}]==uglyA2

varNicePrintingCA1=varReductionConstraint[{2,-Sp}]==varReductCA1
varNicePrintingCA2=varReductionConstraint[{3,-Sp}]==varReductCA2
NicePrintingCA1=ReductionConstraint[{2,-Sp}]==reductCA1
NicePrintingCA2=ReductionConstraint[{3,-Sp}]==reductCA2
uglyNicePrintingCA1=uglyReductionConstraint[{2,-Sp}]==uglyReductCA1
uglyNicePrintingCA2=uglyReductionConstraint[{3,-Sp}]==uglyReductCA2




NicePrintingToyModelTRA={NicePrintingPhiT,NicePrintingvarPhiT, NicePrintinguglyT,NicePrintingPhiR,NicePrintingvarPhiR,NicePrintinguglyR ,NicePrintingPhiA1,NicePrintingvarPhiA1,NicePrintinguglyA1,NicePrintingPhiA2,NicePrintingvarPhiA2,NicePrintinguglyA2,NicePrintingCT,NicePrintingCR,NicePrintingCA1,NicePrintingCA2,varNicePrintingCT,varNicePrintingCR, varNicePrintingCA1,varNicePrintingCA2,uglyNicePrintingCT ,uglyNicePrintingCR,uglyNicePrintingCA1,uglyNicePrintingCA2}

ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA=Flatten[ApplyRule/@NicePrintingToyModelTRA];


DefScalarFunction[TransitionFunctionGood,PrintAs->"\!\(\*SubscriptBox[\(\[Chi]\), \(g\)]\)"]
DefScalarFunction[TransitionFunctionBad,PrintAs->"\!\(\*SubscriptBox[\(\[Chi]\), \(b\)]\)"]
DefScalarFunction[TransitionFunctionUgly,PrintAs->"\!\(\*SubscriptBox[\(\[Chi]\), \(u\)]\)"]
DefScalarFunction[TransitionFunction,PrintAs->"\[Chi]"]
DefScalarFunction[LogaritmicLossFunction,PrintAs->"\[Xi]"]





DefChart[sphyp,M4,{0,1,2,3},{t[],r[],\[Theta][],\[Phi][]},ChartColor->RGBColor[0,0,1] (*,FormatBasis\[Rule]{"Partials","Differentials"}*)]

DefScalarFunction[Hprime,PrintAs->"H'"]
DefScalarFunction[Rprime,PrintAs->"R'"]
DefScalarFunction[scalarR,PrintAs->"R"]

ComponentValue[Basis[{0,-sphyp},{0,Sp}],1]
ComponentValue[Basis[{0,-sphyp},{1,Sp}],0]
ComponentValue[Basis[{0,-sphyp},{2,Sp}],0]
ComponentValue[Basis[{0,-sphyp},{3,Sp}],0]
ComponentValue[Basis[{1,-sphyp},{0,Sp}],Hprime*Rprime]
ComponentValue[Basis[{1,-sphyp},{1,Sp}],Rprime]
ComponentValue[Basis[{1,-sphyp},{2,Sp}],0]
ComponentValue[Basis[{1,-sphyp},{3,Sp}],0]
(* Angular ones*)
ComponentValue[Basis[{2,-sphyp},{0,Sp}],0]
ComponentValue[Basis[{2,-sphyp},{1,Sp}],0]
ComponentValue[Basis[{2,-sphyp},{2,Sp}],1]
ComponentValue[Basis[{2,-sphyp},{3,Sp}],0]
ComponentValue[Basis[{3,-sphyp},{0,Sp}],0]
ComponentValue[Basis[{3,-sphyp},{1,Sp}],0]
ComponentValue[Basis[{3,-sphyp},{2,Sp}],0]
ComponentValue[Basis[{3,-sphyp},{3,Sp}],1]







ComponentArray[Basis[{-a,-sphyp},{b,Sp}]]//MatrixForm
ToValues[%]//MatrixForm
Inverse[%]//MatrixForm
InputForm[%]




AllComponentValues[Basis[{-a,-Sp},{b,sphyp}],{{1,0,0,0},{-Hprime,Rprime^(-1),0,0},{0,0,1,0},{0,0,0,1}}]

ComponentArray[Basis[{-a,-Sp},{b,sphyp}]]//MatrixForm
ToValues[%]//MatrixForm



DefChart[Li,M4,{0,1,2,3},{u[],s[],\[Theta][],\[Phi][]},ChartColor->RGBColor[0,1,0] (*,FormatBasis\[Rule]{"Partials","Differentials"}*)]


ComponentValue[Basis[{0,-Sp},{0,Li}],1]
ComponentValue[Basis[{0,-Sp},{1,Li}],0]
ComponentValue[Basis[{0,-Sp},{2,Li}],0]
ComponentValue[Basis[{0,-Sp},{3,Li}],0]
ComponentValue[Basis[{1,-Sp},{0,Li}],-1]
ComponentValue[Basis[{1,-Sp},{1,Li}],1/R[]]
ComponentValue[Basis[{1,-Sp},{2,Li}],0]
ComponentValue[Basis[{1,-Sp},{3,Li}],0]
(* Angular ones*)
ComponentValue[Basis[{2,-Sp},{0,Li}],0]
ComponentValue[Basis[{2,-Sp},{1,Li}],0]
ComponentValue[Basis[{2,-Sp},{2,Li}],1]
ComponentValue[Basis[{2,-Sp},{3,Li}],0]
ComponentValue[Basis[{3,-Sp},{0,Li}],0]
ComponentValue[Basis[{3,-Sp},{1,Li}],0]
ComponentValue[Basis[{3,-Sp},{2,Li}],0]
ComponentValue[Basis[{3,-Sp},{3,Li}],1]


ComponentArray[Basis[{-a,-Sp},{b,Li}]]//MatrixForm
ToValues[%]//MatrixForm
Inverse[%]//MatrixForm
InputForm[%]


AllComponentValues[Basis[{-a,-Li},{b,Sp}],{{1,0,0,0},{R[],R[],0,0},{0,0,1,0},{0,0,0,1}}]


ComponentArray[Basis[{-a,-Li},{b,Sp}]]//MatrixForm
ToValues[%]//MatrixForm


(*The relation between {g,b, u ,  Subscript[g, \[Pi]], Subscript[b, \[Pi]],Subscript[u, \[Pi]],Subscript[g, R], Subscript[b, R],Subscript[u, R],Subscript[g, A],Subscript[b, A], Subscript[u, A]} and  {g,b,u, g^+, b^+,u^+, g^-, b^-,u^-,Subscript[g, A],Subscript[b, A],Subscript[u, A] }  is given by  *)


TransitionFunctionGood=TransitionFunction
TransitionFunctionBad=TransitionFunction
TransitionFunctionUgly=TransitionFunction


DefinitionOfCharacteristicVariables={DLphi==PhiR-PiPhiT,
DLbarphi==-PhiR-PiPhiT}
ExpressCharacteristicVariablesInNormalVariables={DefinitionOfCharacteristicVariables[[1]][[1]]==DefinitionOfCharacteristicVariables[[1]][[2]],
DefinitionOfCharacteristicVariables[[2]][[1]]==DefinitionOfCharacteristicVariables[[2]][[2]]};
ApplyRuleExpressCharacteristicVariablesInNormalVariables=Flatten[ApplyRule/@ExpressCharacteristicVariablesInNormalVariables];
(**)
DefinitionOfvarCharacteristicVariables={varDLphi==varPhiR-PivarPhiT,
varDLbarphi==-varPhiR-PivarPhiT}
ExpressvarCharacteristicVariablesInNormalVariables={DefinitionOfvarCharacteristicVariables[[1]][[1]]==DefinitionOfvarCharacteristicVariables[[1]][[2]],
DefinitionOfvarCharacteristicVariables[[2]][[1]]==DefinitionOfvarCharacteristicVariables[[2]][[2]]};
ApplyRuleExpressvarCharacteristicVariablesInNormalVariables=Flatten[ApplyRule/@ExpressvarCharacteristicVariablesInNormalVariables];
(**)
DefinitionOfuglyCharacteristicVariables={DLugly==uglyR-PiuglyT,
DLbarugly==-uglyR-PiuglyT}
ExpressuglyCharacteristicVariablesInNormalVariables={DefinitionOfuglyCharacteristicVariables[[1]][[1]]==DefinitionOfuglyCharacteristicVariables[[1]][[2]],
DefinitionOfuglyCharacteristicVariables[[2]][[1]]==DefinitionOfuglyCharacteristicVariables[[2]][[2]]};
ApplyRuleExpressuglyCharacteristicVariablesInNormalVariables=Flatten[ApplyRule/@ExpressuglyCharacteristicVariablesInNormalVariables];
(******)
UsualVariablesInCharacteristicVariables=Flatten[Solve[DefinitionOfCharacteristicVariables,{PiPhiT,PhiR}]];
ExpressVariablesInCharacteristicVariables={UsualVariablesInCharacteristicVariables[[1]][[1]]==UsualVariablesInCharacteristicVariables[[1]][[2]],
UsualVariablesInCharacteristicVariables[[2]][[1]]==UsualVariablesInCharacteristicVariables[[2]][[2]]};
ApplyRuleNormalVariablesToCharacteristicVariables=Flatten[ApplyRule/@ExpressVariablesInCharacteristicVariables];
(**)
UsualVariablesInvarCharacteristicVariables=Flatten[Solve[DefinitionOfvarCharacteristicVariables,{PivarPhiT,varPhiR}]];
ExpressVariablesInvarCharacteristicVariables={UsualVariablesInvarCharacteristicVariables[[1]][[1]]==UsualVariablesInvarCharacteristicVariables[[1]][[2]],
UsualVariablesInvarCharacteristicVariables[[2]][[1]]==UsualVariablesInvarCharacteristicVariables[[2]][[2]]};
ApplyRuleNormalVariablesTovarCharacteristicVariables=Flatten[ApplyRule/@ExpressVariablesInvarCharacteristicVariables];
(**)
UsualVariablesInuglyCharacteristicVariables=Flatten[Solve[DefinitionOfuglyCharacteristicVariables,{PiuglyT,uglyR}]];
ExpressVariablesInuglyCharacteristicVariables={UsualVariablesInuglyCharacteristicVariables[[1]][[1]]==UsualVariablesInuglyCharacteristicVariables[[1]][[2]],
UsualVariablesInuglyCharacteristicVariables[[2]][[1]]==UsualVariablesInuglyCharacteristicVariables[[2]][[2]]};
ApplyRuleNormalVariablesTouglyCharacteristicVariables=Flatten[ApplyRule/@ExpressVariablesInuglyCharacteristicVariables];


(* We define the rescaled variabl es  {G,X,U, G^+, X^+,U ^+,G^-,  X^-,U ^-,Subscript[G, A],Subscript[X, A] ,Subscript[U, A]}   as follow*)


DefScalarFunction[eta, PrintAs->"\[Eta]"]
DefScalarFunction[etaA1, PrintAs->"\!\(\*SubscriptBox[\(\[Eta]\), SubscriptBox[\(A\), \(1\)]]\)"]
DefScalarFunction[etaA2, PrintAs->"\!\(\*SubscriptBox[\(\[Eta]\), SubscriptBox[\(A\), \(2\)]]\)"]


NewCure={Xp==Bplus + (R[]/TransitionFunctionBad[R[]])Bzero + (1/8)*(R[]/TransitionFunctionBad[R[]])*eta,
Xm== Bminus+(1/4)*((LogaritmicLossFunction[R[]]-1))*CDflat[{0,-Sp}][eta],
X==Bzero  + (((LogaritmicLossFunction[R[]]-1))/8)*eta,
XA1==BA1+ (((LogaritmicLossFunction[R[]]-1))/8)*etaA1,
XA2==BA2 + ((LogaritmicLossFunction[R[]]-1)/8)*etaA2};


NewCure;
%/.Bplus-> TransitionFunctionBad[R[]]^2*DLphi;
%/.Bminus-> TransitionFunctionBad[R[]]*DLbarphi;
%/.Bzero-> TransitionFunctionBad[R[]]*Phi;
%/.BA1-> TransitionFunctionBad[R[]]*PhiA1;
%/.BA2-> TransitionFunctionBad[R[]]*PhiA2;
Cure={Xp==Phi*R[]+(eta*R[])/(8*TransitionFunction[R[]])+DLphi*TransitionFunction[R[]]^2,Xm==DLbarphi*TransitionFunction[R[]]+((-1+LogaritmicLossFunction[R[]])*CDflat[{0,-Sp}][eta])/4,X==(eta*(-1+LogaritmicLossFunction[R[]]))/8+Phi*TransitionFunction[R[]],XA1==(etaA1*(-1+LogaritmicLossFunction[R[]]))/8+PhiA1*TransitionFunction[R[]],XA2==(etaA2*(-1+LogaritmicLossFunction[R[]]))/8+PhiA2*TransitionFunction[R[]]}


Flatten[Expand[Simplify[Solve[Flatten[Cure], {DLphi, DLbarphi,Phi,PhiA1,PhiA2}]]]];
(*%[[1]][[1]]==%[[1]][[2]]*)
bplusres=DLphi==-(eta*R[])/(4*TransitionFunction[R[]]^3)-(X*R[])/TransitionFunction[R[]]^3+(eta*LogaritmicLossFunction[R[]]*R[])/(8*TransitionFunction[R[]]^3)+Xp/TransitionFunction[R[]]^2;
Flatten[Expand[Simplify[Solve[Flatten[Cure], {DLphi, DLbarphi,Phi,PhiA1,PhiA2}]]]];
(*%[[2]][[1]]==%[[2]][[2]]*)
bminusres=DLbarphi==Xm/TransitionFunction[R[]]+CDflat[{0,-Sp}][eta]/(4*TransitionFunction[R[]])-(LogaritmicLossFunction[R[]]*CDflat[{0,-Sp}][eta])/(4*TransitionFunction[R[]]);
Flatten[Expand[Simplify[Solve[Flatten[Cure], {DLphi, DLbarphi,Phi,PhiA1,PhiA2}]]]];
(*%[[3]][[1]]==%[[3]][[2]]*)
bres=Phi==eta/(8*TransitionFunction[R[]])+X/TransitionFunction[R[]]-(eta*LogaritmicLossFunction[R[]])/(8*TransitionFunction[R[]]);
Flatten[Expand[Simplify[Solve[Flatten[Cure], {DLphi, DLbarphi,Phi,PhiA1,PhiA2}]]]];
(*%[[4]][[1]]==%[[4]][[2]]*)
bA1res=PhiA1==etaA1/(8*TransitionFunction[R[]])+XA1/TransitionFunction[R[]]-(etaA1*LogaritmicLossFunction[R[]])/(8*TransitionFunction[R[]]);
Flatten[Expand[Simplify[Solve[Flatten[Cure], {DLphi, DLbarphi,Phi,PhiA1,PhiA2}]]]];
(*%[[5]][[1]]==%[[5]][[2]]*)
bA2res=PhiA2==etaA2/(8*TransitionFunction[R[]])+XA2/TransitionFunction[R[]]-(etaA2*LogaritmicLossFunction[R[]])/(8*TransitionFunction[R[]]);


bplusres/.TransitionFunctionBad[R[]]->1/.R[]->0;
bminusres/.LogaritmicLossFunction[R[]]-> 1/.TransitionFunctionBad[R[]]->1/.R[]->0;
bres/.LogaritmicLossFunction[R[]]-> 1/.TransitionFunctionBad[R[]]->1/.R[]->0;
bA1res/.LogaritmicLossFunction[R[]]-> 1/.TransitionFunctionBad[R[]]->1/.R[]->0;
bA2res/.LogaritmicLossFunction[R[]]-> 1/.TransitionFunctionBad[R[]]->1/.R[]->0;


varRescaledCharacteristicVariables={varDLphi==(1/TransitionFunctionGood[R[]]^2)*(varRescDLphi-(R[]/TransitionFunctionGood[R[]])varRescPhi),
varPhi==(1/TransitionFunctionGood[R[]])*varRescPhi,
varDLbarphi==(1/TransitionFunctionGood[R[]])*varRescDLbarphi,
varPhiA1==(1/TransitionFunctionGood[R[]])*varRescPhiA1,
varPhiA2==(1/TransitionFunctionGood[R[]])*varRescPhiA2}
ApplyRulevarRescaledCharacteristicVariables=Flatten[ApplyRule/@varRescaledCharacteristicVariables];
(**)
uglyRescaledCharacteristicVariables={DLugly==(1/TransitionFunctionUgly[R[]]^(3))*(RescDLugly -(2R[]/TransitionFunctionUgly[R[]])*Rescugly),
DLbarugly==(1/TransitionFunctionUgly[R[]]^(2))*RescDLbarugly,
ugly==(1/TransitionFunctionUgly[R[]]^(2))*Rescugly,uglyA1==(1/TransitionFunctionUgly[R[]]^(2))*RescuglyA1,
uglyA2==(1/TransitionFunctionUgly[R[]]^(2))*RescuglyA2}
ApplyRuleuglyRescaledCharacteristicVariables=Flatten[ApplyRule/@uglyRescaledCharacteristicVariables];
(**)
CureBadsDirectlyFromUnrescaledBads={bplusres, bminusres, bres, bA1res,bA2res  }
ApplyRuleCureBadsDirectlyFromUnrescaledBads=Flatten[ApplyRule/@CureBadsDirectlyFromUnrescaledBads];


DefConstantSymbol[gamma, PrintAs->"\[Gamma]"]


SubstituteHprimeChiAndXiExplicit={Hprime==1-1/Rprime,
TransitionFunction[R[]] ==Sqrt[1+R[]^2],
Derivative[1][TransitionFunction][R[]]==D[Sqrt[1+R[]^2],R[]],
LogaritmicLossFunction[R[]]== 1+Log[Sqrt[1+R[]^2]],
Derivative[1][LogaritmicLossFunction][R[]]==D[ 1+Log[Sqrt[1+R[]^2]],R[]],gamma2==gamma/Sqrt[1+R[]^2]}
ApplyRuleSubstituteHprimeChiAndXiExplicit=Flatten[ApplyRule/@SubstituteHprimeChiAndXiExplicit];


DefScalarFunction[DivSphereG, PrintAs->"Div(G)"]
DefScalarFunction[DivSphereU, PrintAs->"Div(U)"]
DefScalarFunction[DivSphereX, PrintAs->"Div(B)"]
DefScalarFunction[DivSphereEta, PrintAs->"Div(\[Eta])"]
IntroduceDivSphereG=CDflat[{2,-sphyp}][varRescPhiA1]==DivSphereG-Csc[\[Theta][]]^2CDflat[{3,-sphyp}][varRescPhiA2]-Cot[\[Theta][]]*varRescPhiA1
IntroduceDivSphereU=CDflat[{2,-sphyp}][RescuglyA1]==DivSphereU-Csc[\[Theta][]]^2CDflat[{3,-sphyp}][RescuglyA2]-Cot[\[Theta][]]*RescuglyA1
IntroduceDivSphereX=CDflat[{2,-sphyp}][XA1]==DivSphereX-Csc[\[Theta][]]^2CDflat[{3,-sphyp}][XA2]-Cot[\[Theta][]]*XA1
IntroduceDivSphereEta=CDflat[{2,-sphyp}][etaA1]==DivSphereEta-Csc[\[Theta][]]^2CDflat[{3,-sphyp}][etaA2]-Cot[\[Theta][]]*etaA1


VariablesToCollect={varRescDLphi,varRescDLbarphi,varRescPhi,Xp,Xm,X,RescDLugly,RescDLbarugly,Rescugly,CDflat[{1,-sphyp}]@varRescDLphi,
 CDflat[{1,-sphyp}]@varRescDLbarphi,CDflat[{1,-sphyp}]@varRescPhi,CDflat[{1,-sphyp}]@Xp,CDflat[{1,-sphyp}]@Xm,CDflat[{1,-sphyp}]@X,
 CDflat[{1,-sphyp}]@RescDLugly,CDflat[{1,-sphyp}]@RescDLbarugly,CDflat[{1,-sphyp}]@Rescugly,(****)varRescDLphi*varRescPhi,
 varRescDLbarphi*varRescPhi,varRescDLphi*varRescDLbarphi,varRescDLphi*Xp,varRescDLphi*Xm,varRescDLphi*X,varRescDLbarphi*Xp,
 varRescDLbarphi*Xm,varRescDLbarphi*X,varRescPhi*Xp,varRescPhi*Xm,varRescPhi*X}
 CollectGamma2[W_]:=Collect[Together[W],gamma2,Factor]
CollectVariables[W_]:=Collect[Simplify[Together[W]],VariablesToCollect,Factor]


DefInertHead[DtildeDiffOp]
PrintAs[DtildeDiffOp]^="\!\(\*OverscriptBox[\(D\), \(~\)]\)"
DefInertHead[DDiffOp]
PrintAs[DDiffOp]^="D"
DefScalarFunction[DHamburgerOverHamburger, PrintAs->"\[Del]\[CapitalXi]/\[CapitalXi]"]
BasicManipulation=(1/R[])-> (1/Rprime)(1/r[]- DHamburgerOverHamburger)
SubsDtildeGm2=varRescDLphi/((-1+Hprime) Rprime r[])-> (1/((-1+Hprime) Rprime) )*(1/2)(DtildeDiffOp[varRescDLphi]-DDiffOp[varRescDLphi])
SubsDtildeUm2=RescDLugly/((-1+Hprime) Rprime r[])-> (1/((-1+Hprime) Rprime) )*(1/2)(DtildeDiffOp[RescDLugly]-DDiffOp[RescDLugly])
SubsDtildeXm2=Xp/((-1+Hprime) Rprime r[])-> (1/((-1+Hprime) Rprime) )*(1/2)(DtildeDiffOp[Xp]-DDiffOp[Xp])


SubsDGp=CDflat[{1,-sphyp}][varRescDLphi]-> (DDiffOp[varRescDLphi])
SubsDGm=CDflat[{1,-sphyp}][varRescDLbarphi]-> (DDiffOp[varRescDLbarphi])
SubsDG=(CDflat[{1,-sphyp}][varRescPhi])-> (DDiffOp[varRescPhi])
(**)
SubsDUp=CDflat[{1,-sphyp}][RescDLugly]-> (DDiffOp[RescDLugly])
SubsDUm=CDflat[{1,-sphyp}][RescDLbarugly]-> (DDiffOp[RescDLbarugly])
SubsDU=(CDflat[{1,-sphyp}][Rescugly])-> (DDiffOp[Rescugly])
(**)
SubsDXp=CDflat[{1,-sphyp}][Xp]-> (DDiffOp[Xp])
SubsDXm=CDflat[{1,-sphyp}][Xm]-> (DDiffOp[Xm])
SubsDX=(CDflat[{1,-sphyp}][X])-> (DDiffOp[X])
(**)
SubsDeta=(CDflat[{1,-sphyp}][eta])-> (DDiffOp[eta])
(**)
SubsDInGBU=Flatten[{SubsDGp,SubsDGm,SubsDG,SubsDUp,SubsDUm,SubsDU,SubsDXp,SubsDXm,SubsDX}]

(**)
SubsDtildeGp=(1/r[])varRescDLphi-> (DtildeDiffOp[varRescDLphi]-DDiffOp[varRescDLphi])/2
SubsDtildeGm=(1/r[])varRescDLbarphi-> (DtildeDiffOp[varRescDLbarphi]-DDiffOp[varRescDLbarphi])/2
(**)
SubsDtildeUp=(1/r[])RescDLugly-> (DtildeDiffOp[RescDLugly]-DDiffOp[RescDLugly])/2
SubsDtildeUm=(1/r[])RescDLbarugly -> (DtildeDiffOp[RescDLbarugly]-DDiffOp[RescDLbarugly])/2
(**)
SubsDtildeXp=(1/r[])Xp-> (DtildeDiffOp[Xp]-DDiffOp[Xp])/2
SubsDtildeXm=(1/r[])Xm-> (DtildeDiffOp[Xm]-DDiffOp[Xm])/2
(**)
ListGamma2andDDtilde=Flatten[{gamma2,DtildeDiffOp[varRescPhi],DtildeDiffOp[varRescDLphi],DDiffOp[varRescDLphi],
DtildeDiffOp[varRescDLbarphi],DDiffOp[varRescPhi],DDiffOp[varRescDLbarphi],DtildeDiffOp[RescDLugly],
DDiffOp[RescDLugly],DtildeDiffOp[RescDLbarugly],DDiffOp[RescDLbarugly],DtildeDiffOp[Xp],DDiffOp[Xp],
DtildeDiffOp[Xm],DDiffOp[Xm],DDiffOp[X],DDiffOp[eta]}]
(**)
CarefulmanipulationXp=Xp*R[]^(-1) ->Xp((-DHamburgerOverHamburger + r[]^(-1))/Rprime)
CarefulmanipulationXm=Xm*R[]^(-1) ->Xm((-DHamburgerOverHamburger + r[]^(-1))/Rprime)



VariablesToCollect1={varRescDLphi,varRescDLbarphi,varRescPhi,Xp,Xm,X,RescDLugly,RescDLbarugly,Rescugly,
 (**) DDiffOp[varRescDLphi],DDiffOp[varRescDLbarphi],DDiffOp[varRescPhi],DDiffOp[Xp],DDiffOp[Xm],DDiffOp[X],
  DDiffOp[RescDLugly],DDiffOp[RescDLbarugly],DDiffOp[Rescugly], (**)DtildeDiffOp[varRescDLphi], 
  DtildeDiffOp[varRescDLbarphi],DtildeDiffOp[varRescPhi],DtildeDiffOp[Xp],DtildeDiffOp[Xm],DtildeDiffOp[X], 
  DtildeDiffOp[RescDLugly],DtildeDiffOp[RescDLbarugly],DtildeDiffOp[Rescugly],varRescDLphi^2,varRescDLbarphi^2, 
  varRescPhi^2,varRescDLphi*varRescDLbarphi,varRescDLphi*varRescPhi,varRescDLbarphi*varRescPhi}
  CollectVariables1[W_]:=Collect[Simplify[Together[W]],VariablesToCollect1,Simplify@Together@#&]
  CollectVariables2[W_]:=Collect[W,VariablesToCollect1,Simplify@Together@#&]
  SphericalSymmetryAssumption={DivSphereG==0,DivSphereU==0,DivSphereX==0,DivSphereEta==0,etaA1==0,etaA2==0}
ApplyRuleSphericalSymmetryAssumption=Flatten[ApplyRule/@SphericalSymmetryAssumption];


SubsGamma2=gamma2==gamma/TransitionFunction[R[]]
DefConstantSymbol[gammauglies,PrintAs->"\!\(\*SubscriptBox[\(\[Gamma]\), \(u\)]\)"]
DefConstantSymbol[indexuglies,PrintAs->"w"]
SubsGamma2uglies=gamma2==gammauglies/TransitionFunction[R[]]^indexuglies


DefScalarFunction[Hamburger, PrintAs->"\[CapitalXi]"]
Subs1=Derivative[1][TransitionFunction][R[]]==r[]/(Sqrt[r[]^2+Hamburger^2])
Subs2=DHamburgerOverHamburger==(-2*r[]/(((n-1)*L^2)*Hamburger^(n-1)))
Subs3=TransitionFunction[R[]]==Sqrt[r[]^2+Hamburger^2]/Hamburger
Subs4=Rprime==(1/Hamburger)(1-DHamburgerOverHamburger*r[])
Subs5=Hprime==1-1/Rprime
Subs6= LogaritmicLossFunction[R[]]==1+Log[TransitionFunction[R[]]]
Subs7=Derivative[1][LogaritmicLossFunction][R[]]==r[]/(Hamburger*TransitionFunction[R[]]^2)
Subs8=R[]==r[]/Hamburger
SubsHamburger=Hamburger==(1-r[]^2/L^2)^(1/(n-1))


DefScalarFunction[RegF,PrintAs-> "F"]
DefScalarFunction[RegB, PrintAs->"B"]
DefScalarFunction[RegC,PrintAs-> "C"]
DefScalarFunction[RegJ,PrintAs-> "J"]
DefScalarFunction[RegK,PrintAs-> "K"]
DefScalarFunction[RegQ,PrintAs-> "Q"]


RegKDef=RegK==Log[Hamburger^2+r[]^2]/r[]
RegJDef=RegJ==Hamburger^(1-k)*Log[Hamburger]/r[]
R[]-TransitionFunction[R[]]
%/.ApplyRule@Subs3;
%/.ApplyRule@Subs8;
Together[%]
RegBDef=RegB==(r[]-Sqrt[Hamburger^2+r[]^2])/Hamburger
RegCDef=RegC == Log[TransitionFunction[R[]]]/(r[]*(1 + Log[TransitionFunction[R[]]]))
RegQDef=RegQ==Log[TransitionFunction[R[]]]/TransitionFunction[R[]]^(q)
Simplify[Hamburger (2 Hamburger^(-1+n) L^2-Hamburger^n L^2-2 Hamburger^(-1+n) L^2 n+Hamburger^n L^2 n-4 r[]^2)]==RegF*Hamburger;
(*Flatten[Solve[%,RegF]];
%[[1]][[1]]\[Equal]%[[1]][[2]];
Expand[%]*)
RegFDef=RegF==2*Hamburger^(-1+n)*L^2-Hamburger^n*L^2-2*Hamburger^(-1+n)*L^2*n+Hamburger^n*L^2*n-4*r[]^2


(*Flatten[Solve[RegJDef,Log[Hamburger]]];
%[[1]][[1]]\[Equal]%[[1]][[2]];*)
SubsLog=Log[Hamburger]==Hamburger^(-1+k)*RegJ*r[]


SubsScreenedF=Simplify[Hamburger (2 Hamburger^(-1+n) L^2-Hamburger^n L^2-2 Hamburger^(-1+n) L^2 n+Hamburger^n L^2 n-4 r[]^2)]-> RegF*Hamburger
SubsScreenedF2=Simplify[2Hamburger (2 Hamburger^(-1+n) L^2-Hamburger^n L^2-2 Hamburger^(-1+n) L^2 n+Hamburger^n L^2 n-4 r[]^2)]->2* RegF*Hamburger
SubsScreenedFalt=Simplify[-Hamburger (2 Hamburger^(-1+n) L^2-Hamburger^n L^2-2 Hamburger^(-1+n) L^2 n+Hamburger^n L^2 n-4 r[]^2)]->- RegF*Hamburger
SubsScreenedF2alt=Simplify[-2Hamburger (2 Hamburger^(-1+n) L^2-Hamburger^n L^2-2 Hamburger^(-1+n) L^2 n+Hamburger^n L^2 n-4 r[]^2)]->-2* RegF*Hamburger
(2(r[]^8)*varRescDLbarphi^2)/(RegF L^2 (-1+n) (Hamburger^2+r[]^2)^(5/2))-(2 *varRescDLbarphi^2 r[]^7)/(RegF L^2 (-1+n) (Hamburger^2+r[]^2)^2)
Together[%]
Factor[%]
SubsRegB=(2(r[]^8)*varRescDLbarphi^2)/(RegF L^2 (-1+n) (Hamburger^2+r[]^2)^(5/2))-(2 varRescDLbarphi^2  r[]^7)/(RegF L^2 (-1+n) (Hamburger^2+r[]^2)^2) ->  Hamburger((2 varRescDLbarphi^2  r[]^7 (RegB))/(RegF L^2 (-1+n) (Hamburger^2+r[]^2)^(5/2)))
ReplaceDifferenceWithRegB=(r[]-Sqrt[Hamburger^2+r[]^2])-> RegB*Hamburger
ReplaceDifferenceWithRegBAlt=-r[] + Sqrt[Hamburger^2 + r[]^2] -> -Hamburger*RegB


HamburgerListXp={Hamburger^(k+n-1),Hamburger^(k+n+1),Hamburger^(k+n+2),Hamburger^(n-1),Hamburger^(n+5),Hamburger^(n+4),
Hamburger^(n+3),Hamburger^(n+2),Hamburger^(n+1),Hamburger^(n)}
CollectHamburgersXp[W_]:=Collect[Simplify[Together[W]],HamburgerListXp,Simplify@#&]

HamburgerListXm={Hamburger^(k-n+1),Hamburger^(k+n-1),Hamburger^(k+n+1),Hamburger^(k+n+2),Hamburger^(n-1),Hamburger^(2-n),Hamburger^(n+5),Hamburger^(n+4),Hamburger^(n+3),Hamburger^(n+2),Hamburger^(n)}
CollectHamburgersXm[W_]:=Collect[Simplify[Together[W]],HamburgerListXm,Simplify@#&]

ForceExpression1=eta Hamburger^(1-n) r[]^2 (Hamburger Log[Hamburger^2+r[]^2]-2 (Hamburger+Hamburger^k RegJ r[]))
ForceExpression2=(Hamburger^(1-n) r[]^2 (-12 Hamburger^(2+k) RegJ r[]^4-4 gamma Hamburger^k RegJ r[]^5 Sqrt[Hamburger^2+r[]^2]+Hamburger r[]^2 (2 RegF r[]+12 r[]^3+RegF Sqrt[Hamburger^2+r[]^2])+Hamburger^3 (3 RegF r[]+12 r[]^3+RegF Sqrt[Hamburger^2+r[]^2])+2 Hamburger Log[Hamburger^2+r[]^2] r[]^3 (3 Hamburger^2+gamma r[] Sqrt[Hamburger^2+r[]^2])))
ForceExpression3=Hamburger^(1-n) r[]^2 (-12 Hamburger^(2+k) RegJ r[]^4+4 Hamburger^k RegJ r[]^5 (r[]-gamma Sqrt[Hamburger^2+r[]^2])+Hamburger r[]^2 (2 RegF r[]+12 r[]^3+RegF Sqrt[Hamburger^2+r[]^2])+Hamburger^3 (3 RegF r[]+12 r[]^3+RegF Sqrt[Hamburger^2+r[]^2])+2 Hamburger Log[Hamburger^2+r[]^2] r[]^3 (3 Hamburger^2+r[] (-r[]+gamma Sqrt[Hamburger^2+r[]^2])))


(***** constraints *******)
(*Flatten[Solve[varReductionConstraintDefinition,SpacetimeDerivativevarPhi[-a]]];
varSubstituteReductionVariableWithConstraint=%[[1]][[1]]\[Equal]%[[1]][[2]];
Basis[{1,-Sp},a]varSubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;*)
varSubstituteReductionVariableWithConstraintR=varPhiR==-varReductCR+CDflat[{1,-Sp}][varPhi];
(**)
(*Basis[{2,-Sp},a]varSubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
varSubstituteReductionVariableWithConstraintA1=varPhiA1==-varReductCA1+CDflat[{2,-Sp}][varPhi];
(**)
(*Basis[{3,-Sp},a]varSubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
varSubstituteReductionVariableWithConstraintA2=varPhiA2==-varReductCA2+CDflat[{3,-Sp}][varPhi];
(**)
varSubstituteReductionVariableWithConstraintAllComponents={varSubstituteReductionVariableWithConstraintR,varSubstituteReductionVariableWithConstraintA1,varSubstituteReductionVariableWithConstraintA2}
ApplyRulevarSubstituteReductionVariableWithConstraintAllComponents=Flatten[ApplyRule/@varSubstituteReductionVariableWithConstraintAllComponents];
(***)
(*Flatten[Solve[ReductionConstraintDefinition,SpacetimeDerivativePhi[-a]]];
SubstituteReductionVariableWithConstraint=%[[1]][[1]]\[Equal]%[[1]][[2]];
Basis[{1,-Sp},a]SubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;*)
SubstituteReductionVariableWithConstraintR=PhiR==-reductCR+CDflat[{1,-Sp}][Phi];
(**)
(*Basis[{2,-Sp},a]SubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
SubstituteReductionVariableWithConstraintA1=PhiA1==-reductCA1+CDflat[{2,-Sp}][Phi];
(**)
(*Basis[{3,-Sp},a]SubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
SubstituteReductionVariableWithConstraintA2=PhiA2==-reductCA2+CDflat[{3,-Sp}][Phi];
(**)
SubstituteReductionVariableWithConstraintAllComponents={SubstituteReductionVariableWithConstraintR,SubstituteReductionVariableWithConstraintA1,SubstituteReductionVariableWithConstraintA2}
ApplyRuleSubstituteReductionVariableWithConstraintAllComponents=Flatten[ApplyRule/@SubstituteReductionVariableWithConstraintAllComponents];
(******)
(*Flatten[Solve[uglyReductionConstraintDefinition,SpacetimeDerivativeugly[-a]]];
uglySubstituteReductionVariableWithConstraint=%[[1]][[1]]\[Equal]%[[1]][[2]];
Basis[{1,-Sp},a]uglySubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;*)
uglySubstituteReductionVariableWithConstraintR=uglyR==-uglyreductCR+CDflat[{1,-Sp}][ugly];
(**)
(*Basis[{2,-Sp},a]uglySubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
uglySubstituteReductionVariableWithConstraintA1=uglyA1==-uglyReductCA1+CDflat[{2,-Sp}][ugly];
(**)
(*Basis[{3,-Sp},a]uglySubstituteReductionVariableWithConstraint;
ContractBasis[%];
%/.ApplyRuleNicePrintingVariablesAndConstraintsToyModelTRA;
ContractMetric[%];*)
uglySubstituteReductionVariableWithConstraintA2=uglyA2==-uglyReductCA2+CDflat[{3,-Sp}][ugly];
(**)
uglySubstituteReductionVariableWithConstraintAllComponents={uglySubstituteReductionVariableWithConstraintR,uglySubstituteReductionVariableWithConstraintA1,uglySubstituteReductionVariableWithConstraintA2}
ApplyRuleuglySubstituteReductionVariableWithConstraintAllComponents=Flatten[ApplyRule/@uglySubstituteReductionVariableWithConstraintAllComponents];

(***************************)
varReductionConstraintToRescaledReductionConstraint={varReductCR==(1/TransitionFunctionGood[R[]]^2)*varRescaledCR,varReductCA1==(1/TransitionFunctionGood[R[]])*varRescaledCA1,varReductCA2==(1/TransitionFunctionGood[R[]])*varRescaledCA2}
(**)
ApplyRulevarReductionConstraintToRescaledReductionConstraint=Flatten[ApplyRule/@varReductionConstraintToRescaledReductionConstraint];
(************)
uglyReductionConstraintToRescaledReductionConstraint={uglyreductCR==(1/TransitionFunctionUgly[R[]]^3)*uglyRescaledCR,uglyReductCA1==(1/TransitionFunctionUgly[R[]]^2)*uglyRescaledCA1,uglyReductCA2==(1/TransitionFunctionUgly[R[]]^2)*uglyRescaledCA2}
(**)
ApplyRuleuglyReductionConstraintToRescaledReductionConstraint=Flatten[ApplyRule/@uglyReductionConstraintToRescaledReductionConstraint];
(*************)
ReductionConstraintToRescaledReductionConstraint={reductCR==(1/TransitionFunctionBad[R[]]^2)*RescaledCR,reductCA1==(1/TransitionFunctionBad[R[]])*RescaledCA1,reductCA2==(1/TransitionFunctionBad[R[]])*RescaledCA2}
(**)
ApplyRuleReductionConstraintToRescaledReductionConstraint=Flatten[ApplyRule/@ReductionConstraintToRescaledReductionConstraint];


DefTensor[EndOfSetUpFile[],M4,PrintAs->"END-OF-SET-UP-FILE"]


EndOfSetUpFile[]
